
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/zipinfo/src/RCS/LoadZip.p,v 1.1 2001/11/29 21:22:32 sauge Exp sauge $" NO-UNDO.

/* Load the Zipinfo data into the database. We use a repeat cuz might blow */
/* out lock tables with a FOR EACH.                                        */

{MakeID2.i}

DEF INPUT PARAMETER pFileName AS CHARACTER NO-UNDO.

DEF VAR lLine        AS CHARACTER NO-UNDO.

REPEAT:

  FIND FIRST ZipCode EXCLUSIVE-LOCK NO-ERROR.
  IF AVAILABLE ZipCode THEN DELETE ZipCode.
  ELSE LEAVE.

END. /* REPEAT: */

/* Open and load the datafile */

INPUT FROM VALUE(pFileName).

/* Ignore first two lines - format and (c) for ZipInfo */

IMPORT UNFORMATTED lLine.
IMPORT UNFORMATTED lLine.

/* Repeatedly load in the records */

REPEAT:
  IMPORT UNFORMATTED lLine.
  RUN ipCreateRecord (INPUT lLine).
END.

INPUT CLOSE.

/********************************************************************/
/*                         INTERNAL PROCEDURES                      */
/********************************************************************/

/* Take the comma delimited ASCII version and create record.  */

PROCEDURE ipCreateRecord:

  DEF INPUT PARAMETER pLine AS CHARACTER NO-UNDO.

  /* Remove " from line */

  ASSIGN pLine = REPLACE (pLine, "~"", "").

  /* Create the record */

  DO TRANSACTION:

  CREATE ZipCode.

  ASSIGN ZipCode.ZipCodeID = MAKEID2(10).

  ASSIGN
  ZipCode.ZipCode = ENTRY(1, pLine)
  ZipCode.City    = ENTRY(2, pLine)
  ZipCode.State   = ENTRY (3, pLine).

  END. /* DO TRANSACTION */

END. /* PROCEDURE ipCreateRecord */

